//#include <xc.h>
#include <stdio.h>
#include "hw.h"



#define	H_WAIT	0
#define	H_SIZE	1
#define	H_ADDR	2
#define	H_TYPE	3
#define	H_DATA	4
#define	H_END	5

//#define	IHX_PARSER_DEBUG_MSG


unsigned char cmd_4b (unsigned long data);
void write_byte (unsigned int addr, unsigned char data);
unsigned char read_byte (unsigned int addr);
void write_page (unsigned int addr, unsigned char * data, unsigned char len);
unsigned char hexa_bin (unsigned char data);
unsigned int parse_char (unsigned char data);
unsigned int bin_cont (unsigned char b3, unsigned char b2, unsigned char b1, unsigned char b0);
void mem_start_write (unsigned int addr);
void mem_write_byte (unsigned char data);
void mem_end_write (void);
void mem_read_range (unsigned int addr, unsigned char * buf, unsigned char len);
unsigned long get_signature (void);
void enter_progmode (void);
void exit_progmode (void);
void erase_target (void);

unsigned char mem_arr[128],tx_s[60];
unsigned char d1;

unsigned char h_len, h_type, h_data[5];
unsigned int	h_addr;
unsigned char h_array[64];
char h_temp[10];
unsigned char h_state, h_substate, h_data_c,h_array_p;

unsigned char state_main, mode_auto,page_size,page_size_temp,mode_lp,rst_logic;
unsigned int addr,addr_highest,parser_retval,addr_max,read_len;



void main (void)
{
hw_init();
dly_ms(300);
tx_str((char *)("AT89S programmer\n"));
addr=0;
addr_max = 0;
mode_lp = 0;
mode_auto = 1;
page_size = 1;
rst_logic = 0;
while (1)
	{
	if (rx_ready())
		{
		d1 =  rx_get();
//		tx_data(d1);
		if ((d1>='a')|(d1>='z'))
			{
			if (d1=='r')
				state_main=2;
			if (d1=='e')
				state_main=3;
			if (d1=='w')
				state_main=4;	
			if (d1=='t')
				state_main=5;
			if (d1=='b')
				state_main=6;
			if (d1=='v')
				state_main=7;
			if (d1=='h')
				{
				tx_str ((char *)(" --- PIC89S PROGRAMMER HELP --- \n"));
				tx_str ((char *)("h: this help\n"));
				tx_str ((char *)("a: toggle auto mode on(erasing-flashing target after "));
				tx_str ((char *)(" receiving HEX file) or off.\n"));
				tx_str ((char *)("p: toggle page sizes - currently 1B/32B\n"));
				tx_str ((char *)("t: check target signature\n"));
				tx_str ((char *)("b: list buffer content\n"));
				tx_str ((char *)("r: list target memory content\n"));
				tx_str ((char *)("e: erase target memory content\n"));
				tx_str ((char *)("w: program target memory with buffer content\n"));
				tx_str ((char *)("v: verify target memory against buffer content\n"));
				tx_str ((char *)("l: toggle 89LP mode\n"));
				tx_str ((char *)("o: toggle reset logic\n"));
				tx_data('\n');
				}
			if (d1=='p')
				{
				if (page_size==1)
					page_size = 32;
				else	if (page_size==32)
					page_size = 64;
				else
					page_size = 1;
				sprintf (tx_s,"page size: %d\n\n",page_size);
				tx_str (tx_s);
				}
				
			if (d1=='a')
				{
				if (mode_auto==0)
					mode_auto = 1;
				else
					mode_auto = 0;
				sprintf (tx_s,"auto mode: %d\n\n",mode_auto);
				tx_str (tx_s);
				}
			if (d1=='o')
				{
				if (rst_logic==0)
					{
					rst_logic = 1;
					sprintf (tx_s,"rst logic: active high\n\n");
					}
				else
					{
					rst_logic = 0;
					sprintf (tx_s,"rst logic: active low\n\n");
					}
				tx_str (tx_s);
				}

			if (d1=='l')
				{
				if (mode_lp==0)
					mode_lp = 1;
				else if (mode_lp==1)
					mode_lp = 2;
				else
					mode_lp = 0;
				sprintf (tx_s,"preamble (89LP4052) mode: %d ",mode_lp);
				tx_str (tx_s);
				if (mode_lp==1) tx_str((char *)("- 1 byte (89LP4052)"));
				if (mode_lp==2) tx_str((char *)("- 2 bytes (89LP214, 6440, 51ED2)"));
				tx_str((char *)("\n\n"));
				}

			}
		else
			{
			parser_retval = parse_char(d1);
			if (parser_retval>0)
				{
				if (mode_auto==0)
					state_main=0;
				else
					state_main=1;
				addr_max = parser_retval;
				sprintf (tx_s,"hex received, %d bytes in buffer\n\n",addr_max);
				tx_str (tx_s);
				}
			}
		}
	if (state_main==1)
		{
		state_main = 103;
		}
		
	if (state_main==2)
		{
		tx_str((char *)("entering programming mode - "));
		enter_progmode();
		sprintf (tx_s,"signature:%6.6lX\n",get_signature());
		tx_str (tx_s);
		sprintf (tx_s,"reading %d bytes from target:\n",addr_max);
		tx_str (tx_s);
		for (addr=0;addr<addr_max;addr=addr+1)
			{
			if ((addr%16)==0) 
				{
				sprintf(tx_s,"\n%4.4X: ",addr);
				tx_str (tx_s);
				}
			d1 = read_byte(addr);
			sprintf(tx_s,"%2.2X ",d1);
			tx_str (tx_s);
			}
		tx_str((char *)("\n\n"));
		exit_progmode();
		state_main=0;
		}

	if ((state_main==3)|(state_main==103))
		{
		tx_str((char *)("entering programming mode - "));
		enter_progmode();
		sprintf (tx_s,"signature:%6.6lX\n",get_signature());
		tx_str (tx_s);
		tx_str ((char *)("erasing target... "));
		erase_target();
		while (read_byte(0)!=0xFF);
		tx_str ((char *)("OK\n\n"));
		exit_progmode();
		if (state_main==103)
			state_main = 104;
		else
			state_main=0;

		}
		
	if ((state_main==4)|(state_main==104))
		{
		tx_str((char *)("entering programming mode - "));
		enter_progmode();
		sprintf (tx_s,"signature:%6.6lX\n",get_signature());
		tx_str (tx_s);
		page_size_temp = page_size;
		if (mode_lp!=0) page_size_temp = 32;
		sprintf (tx_s,"writing %d bytes to target in %dB pages:\n",addr_max,page_size_temp);
		tx_str (tx_s);
		if ((page_size==1)&(mode_lp==0))
			{
			addr = 0;
			while (addr<addr_max)
				{
				tx_str ((char *)("*"));
				mem_read_range(addr,mem_arr,16);
				for (d1=0;d1<16;d1++)
					{
					write_byte(addr+d1,mem_arr[d1]);
					while (read_byte(addr+d1)!=mem_arr[d1]);
					}
				addr = addr + 16;
				}
			}
		else
			{
			addr = 0;
			while (addr<addr_max)
				{
				tx_str((char *)("*"));
				mem_read_range(addr,mem_arr,page_size_temp);
				write_page(addr,mem_arr,page_size_temp);
				while (read_byte(addr+(page_size_temp-1))!=mem_arr[page_size_temp-1]);
				addr = addr + page_size_temp;
				}
			}
		tx_str((char *)(" OK \n\n"));
		exit_progmode();
		if (state_main==104)
			state_main = 107;
		else
			state_main=0;

		
		}

	if (state_main==5)
		{
		tx_str((char *)("entering programming mode - "));
		enter_progmode();
		sprintf (tx_s,"signature:%6.6lX, Vt: %d mV\n\n",get_signature(),get_vdd());
		tx_str (tx_s);
		exit_progmode();
		state_main=0;
		}

	if (state_main==6)
		{
		sprintf (tx_s,"reading %d bytes from buffer:\n",addr_max);
		tx_str (tx_s);
		for (addr=0;addr<addr_max;addr=addr+1)
			{
			if ((addr%16)==0) 
				{
				sprintf(tx_s,"\n%4.4X: ",addr);
				tx_str (tx_s);
				}
			mem_read_range(addr,mem_arr,1);
			sprintf(tx_s,"%2.2X ",mem_arr[0]);
			tx_str (tx_s);
			}
		tx_str((char *)("\n\n"));
		state_main=0;
		}

	if ((state_main==7)|(state_main==107))
		{
		tx_str((char *)("entering programming mode - "));
		enter_progmode();
		sprintf (tx_s,"signature:%6.6lX\n",get_signature());
		tx_str (tx_s);
		sprintf (tx_s,"verifying %d bytes:",addr_max);
		tx_str (tx_s);
		for (addr=0;addr<addr_max;addr=addr+1)
			{
			mem_read_range(addr,mem_arr,1);
			d1 = read_byte(addr);
			if (d1!=mem_arr[0])
				{
				sprintf (tx_s,"\nverify error at byte %d:\n",addr);
				tx_str (tx_s);
				sprintf (tx_s,"expected %2.2X, read %2.2X\n",mem_arr[0],d1);
				tx_str (tx_s);
				break;
				}
			}
		tx_str((char *)(" OK\n\n"));
		exit_progmode();
		if (state_main==107)
			state_main = 0;
		else
			state_main=0;
		}

		
		
	}

}



unsigned long cmd;


void erase_target (void)
{
if (mode_lp==0)
	cmd_4b(0xAC800000);
else
	{
	set_cs(0);
	spi_byte(0xAA);
	if (mode_lp==2) spi_byte(0x55);
	spi_byte(0x8A);
	set_cs(1);
	}
}

void enter_progmode (void)
{
enter_progmode_pins(mode_lp,rst_logic);
if (mode_lp==0)
	cmd_4b(0xAC530000);
else
	{
	set_cs(0);
	spi_byte(0xAA);
	if (mode_lp==2) spi_byte(0x55);
	spi_byte(0xAC);
	spi_byte(0x53);
	set_cs(1);
	}
}

void exit_progmode (void)
{
exit_progmode_pins(rst_logic);
}


unsigned long get_signature (void)
{
unsigned char s1,s2,s3;
if (mode_lp==0)
	{
	s1 = cmd_4b(0x28000000);
	s2 = cmd_4b(0x28000100);
	s3 = cmd_4b(0x28000200);
	if ((s1==s3)&(s1!=0xFF)&(s2==0xFF))
		{
		s1 = cmd_4b(0x28000000);
		s2 = cmd_4b(0x28010000);
		s3 = cmd_4b(0x28020000);
		}
	if ((s1==0xFF)&(s2==0xFF)&(s3==0xFF))
		{
		s1 = cmd_4b(0x28003000);
		s2 = cmd_4b(0x28003100);
		s3 = cmd_4b(0x28003200);
		}
	}
else
{
	if ((mode_lp==1)|(mode_lp==2))
	{
	s1 = cmd_4b(0x38000000);
	s2 = cmd_4b(0x38000100);
	s3 = cmd_4b(0x38000200);
	}
}
cmd = ((((unsigned long)(s1))<<16)|(((unsigned long)(s2))<<8)|(((unsigned long)(s3))<<0));
return cmd;
}

void write_page (unsigned int addr, unsigned char * data, unsigned char len)
{
unsigned char i;
if (mode_lp!=0) set_cs(0);
if ((mode_lp==2)|(mode_lp==1)) spi_byte(0xAA);
if (mode_lp==2) spi_byte(0x55);
spi_byte(0x50);
spi_byte(addr>>8);
spi_byte(addr);
for (i=0;i<len;i++) spi_byte(data[i]);
if (mode_lp!=0) set_cs(1);
}

void write_byte (unsigned int addr, unsigned char data)
{
cmd = (((unsigned long)(addr))<<8)| 0x40000000|data;
cmd_4b(cmd);
}

unsigned char read_byte (unsigned int addr)
{
if (mode_lp!=0) cmd = (((unsigned long)(addr))<<8)| 0x30000000;
else cmd = (((unsigned long)(addr))<<8)| 0x20000000;;
return cmd_4b(cmd);
}

unsigned char cmd_4b (unsigned long data)
{
unsigned char tmp;
if (mode_lp!=0) set_cs(0);
if ((mode_lp==2)|(mode_lp==1)) spi_byte(0xAA);
if (mode_lp==2) spi_byte(0x55);
spi_byte(data>>24);
spi_byte(data>>16);
spi_byte(data>>8);
tmp = spi_byte(data>>0);
if (mode_lp!=0) set_cs(1);
return tmp;
}




unsigned int parse_char (unsigned char data)
{
unsigned int t1,t2;
unsigned int retval;
retval = 0;
if (data==':')
	{
	h_state = H_SIZE;
	h_substate = 0;
	mem_end_write();
	return retval;
	}

if (h_state==H_SIZE)
	{
	h_data[h_substate++] = hexa_bin(data);
	if (h_substate==2)
		{
		h_state = H_ADDR;
		h_substate = 0;
		h_len = bin_cont(h_data[1],h_data[0],0,0);
		#ifdef	IHX_PARSER_DEBUG_MSG
		tx_data(0x0D);
		tx_data('S');
		#endif
		#ifndef	IHX_PARSER_DEBUG_MSG
		tx_data('@');
		#endif
		}
	return retval;
	}

if (h_state==H_ADDR)
	{
	h_data[h_substate++] = hexa_bin(data);
	if (h_substate==4)
		{
		h_state = H_TYPE;
		h_substate = 0;
		h_addr = bin_cont(h_data[3],h_data[2],h_data[1],h_data[0]);
		#ifdef	IHX_PARSER_DEBUG_MSG
		tx_data('A');
		#endif
		mem_start_write(h_addr);
		}

	return retval;
	}

if (h_state==H_TYPE)
	{
	h_data[h_substate++] = hexa_bin(data);
	if (h_substate==2)
		{
		h_state = H_DATA;
		h_substate = 0;
		h_type = bin_cont(h_data[1],h_data[0],0,0);
		h_array_p=0;
		#ifdef	IHX_PARSER_DEBUG_MSG
		tx_data('T');
		#endif
		if (h_type == 0x01)
			{
			h_state = H_END;	
			h_substate = 0;
			#ifdef	IHX_PARSER_DEBUG_MSG
			tx_data('~');
			#endif
			mem_end_write();
			retval = 0;
//			set_drivers_emu();
			}
		}
	else
		{
		}
	return retval;
	}

if (h_state==H_DATA)
	{
	h_data[h_substate++] = hexa_bin(data);
	if (h_substate==2)
		{
		h_data_c = bin_cont(h_data[1],h_data[0],0,0);
		h_array[h_array_p++] = h_data_c;
		h_substate = 0;
		#ifdef	IHX_PARSER_DEBUG_MSG
		tx_data('D');
		#endif
		mem_write_byte(h_data_c);
		if (h_array_p==h_len)
			{
			if (addr_highest<(h_addr+h_len)) 
				addr_highest=(h_addr+h_len);
			//h_len, h_addr, h_array
//			for (d2=0;d2<h_len;d2++) 
//				mem_arr[h_addr + d2] = h_array[d2];
			h_state = H_WAIT;
			}
		else
			{

			}
		}
	return retval;
	}
if (h_state==H_END)
	{
	h_substate++;
	if ((h_substate==2)|(data<' '))
		{
		#ifdef	IHX_PARSER_DEBUG_MSG
		tx_data('!');
		tx_data('e');
		tx_data('n');
		tx_data('d');
		#endif
		tx_data(0x0D);
		retval = addr_highest;
		addr_highest = 0;
		h_state = H_WAIT;
		}
	return retval;
	}
return retval;
}


unsigned char hexa_bin (unsigned char data)
{
if ((data>='0')&(data<='9'))
	return data - '0';
if ((data>='A')&(data<='F'))
	return data - 'A' + 10;
else
	return 0;

}

unsigned int bin_cont (unsigned char b3, unsigned char b2, unsigned char b1, unsigned char b0)
{
unsigned int t1;
t1 = b0;
t1 = t1<<4;
t1 = t1 | b1;
t1 = t1<<4;
t1 = t1 | b2;
t1 = t1<<4;
t1 = t1 | b3;
return t1;
}


 